﻿;;	CADaSchtroumpf. 2020-03-12
;;
(defun str2lst (str sep / pos)
	(if (setq pos (vl-string-search sep str))
		(cons
			(substr str 1 pos)
			(str2lst (substr str (+ (strlen sep) pos 1)) sep)
		)
		(list str)
	)
)
(defun ListBox (title msg keylab flag / tmp file dcl_id choice)
	(setq
		tmp (vl-filename-mktemp "tmp.dcl")
		file (open tmp "w")
	)
	(write-line
		(strcat "ListBox:dialog{label=\"" title "\";")
		file
	)
	(if (and msg (/= msg ""))
		(write-line (strcat ":text{label=\"" msg "\";}") file)
	)
	(write-line
		(cond
			((= 0 flag) "spacer;:popup_list{key=\"lst\";")
			((= 1 flag) "spacer;:list_box{key=\"lst\";")
			(T "spacer;:list_box{key=\"lst\";multiple_select=true;")
		)
		file
	)
	(write-line "}spacer;ok_cancel;}" file)
	(close file)
	(setq dcl_id (load_dialog tmp))
	(if (not (new_dialog "ListBox" dcl_id))
		(exit)
	)
	(start_list "lst")
	(mapcar 'add_list (mapcar 'cdr keylab))
	(end_list)
	(action_tile
		"accept"
		"(or (= (get_tile \"lst\") \"\")
			(if (= 2 flag)
				(progn
					(foreach n (str2lst (get_tile \"lst\") \" \")
						(setq choice (cons (nth (atoi n) (mapcar 'car keylab)) choice))
					)
					(setq choice (reverse choice))
				)
				(setq choice (nth (atoi (get_tile \"lst\")) (mapcar 'car keylab)))
			)
		)
		(done_dialog)"
	)
	(start_dialog)
	(unload_dialog dcl_id)
	(vl-file-delete tmp)
	choice
)
(defun c:All_OD2CSV ( / js sel_tbl file_name l_file key_sep n obj tbllist count f_open tbldef tblstr fldnamelist fldtypelist fldnme fldtyp numrec ct l_typ l_val cttemp l_tbl l_count)
	(setq js (ssget "_X" '((0 . "*") (410 . "Model"))))
	(cond
		(js
			(setq sel_tbl (listbox "Object data" "Select table of object data" (mapcar 'cons (ade_odtablelist) (ade_odtablelist)) 2))
			(if sel_tbl
				(setq
					file_name (getfiled "File to create ?: " (strcat (getvar "dwgprefix") (substr (getvar "dwgname") 1 (- (strlen (getvar "dwgname")) 3)) "csv") "csv" 37)
					l_count (mapcar '(lambda (x) (cons x 0)) sel_tbl)
					l_tbl nil
				)
			)
			(if (null file_name) (exit))
			(setq
				file_name (substr file_name 1 (- (strlen file_name) 4))
				l_file (mapcar '(lambda (x) (strcat file_name "&" x ".csv")) sel_tbl)
			)
			(initget "SPace Comma SEmicolon Tabulation")
			(setq key_sep (getkword "\nSeparator [SPace/Comma/SEmicolon/Tabulation]? <SEmicolon>: "))
			(cond
				((eq key_sep "SPpace") (setq str_sep " "))
				((eq key_sep "Comma") (setq str_sep ","))
				((eq key_sep "Tabulation") (setq str_sep "\t"))
				(T (setq str_sep ";"))
			)
			(mapcar 'vl-file-delete l_file)
			(repeat (setq n (sslength js))
				(setq obj (ssname js (setq n (1- n))))
				(cond
					((setq tbllist (ade_odgettables obj))
						(foreach tbl tbllist
							(cond
								((member tbl sel_tbl)
									(setq
										f_open (open (strcat file_name "&" tbl ".csv") "a")
										tbldef (ade_odtabledefn tbl)
										tblstr (cdr (nth 2 tbldef))
										fldnamelist ()
										fldtypelist ()
									)
									(foreach fld tblstr
										(setq
											fldnme (cdr (nth 0 fld))
											fldtyp (cdr (nth 2 fld))
											fldnamelist (append fldnamelist (list fldnme))
											fldtypelist (append fldtypelist (list fldtyp))
										)
									)
									(if (not (member tbl l_tbl))
										(progn
											(write-line tbl f_open)
											(write-line (strcat "HANDLE" str_sep (apply 'strcat (mapcar '(lambda (x) (strcat x str_sep )) fldnamelist)) "Number of records") f_open)
											(write-line (strcat "Character" str_sep (apply 'strcat (mapcar '(lambda (x) (strcat x str_sep )) fldtypelist)) "Integer") f_open)
										)
									)
									(setq numrec (ade_odrecordqty obj tbl) ct 0 l_typ nil l_val nil)
									(while (< ct numrec)
										(setq cttemp 0)
										(foreach fld fldnamelist
											(setq
												l_typ (cons (nth cttemp fldtypelist) l_typ)
												cttemp (1+ cttemp)
												l_val (cons (ade_odgetfield obj tbl fld ct) l_val)
											)
										)
										(setq l_val
											(mapcar
												'(lambda (x y / )
													(cond
														((eq y "Character") x)
														((eq y "Integer") (itoa (fix x)))
														((eq y "Real") (rtos x 2 16))
														((eq y "Point") (strcat (rtos (car x) 2 16) "," (rtos (cadr x) 2 16) "," (rtos (caddr x) 2 16)))
													)
												)
												l_val
												l_typ
											)
										)
										(write-line (strcat (strcat "'" (cdr (assoc 5 (entget obj)))) str_sep (apply 'strcat (mapcar '(lambda (x) (strcat x str_sep )) (reverse l_val))) (itoa ct)) f_open)
										(setq
											ct (1+ ct)
											l_count (subst (cons tbl (1+ (cdr (assoc tbl l_count)))) (assoc tbl l_count) l_count)
											l_val nil
										)
									)
									(close f_open)
								)
							)
						)
						(setq l_tbl (append tbllist l_tbl))
					)
				)
			)
			(alert (apply 'strcat (mapcar '(lambda (el) (strcat "\n" (itoa (cdr el)) " lines of data object write for the table " (car el))) l_count)))
		)
	)
	(prin1)
)